﻿# -*- coding: utf-8 -*-

import copy

#穴をふさぐ
#縁の辺（隣接面が一つ）を選択状態でこのスクリプトを実行すると、エッジバウンダリー選択を行った後、ポリゴンで閉じます
#結果を確認してから処理を確定するように変更

#上位パートに変換がかかっていると使用できないように変更（2010.03.03）

#shade1202に対応
#shade1301に対応


#動作条件
#ポリゴンメッシュ
#編集モード
#辺選択モード
#辺が一つでも選択されている事
#最後に選択した辺の隣接面が一つ以下の場合のみ機能

#アルゴリズム変更（2010.01.31）


def boundary_sel2(ashape,imaedge,vv,eflist,velist):
  startedge=imaedge
  mugen=0


  while True:
    if len(velist[vv])>1:
      tvelist=copy.copy(velist[vv])
      tvelist.remove(imaedge)
      hantei=0
      for i in tvelist:
        if len(eflist[i])<2:
          tempedge=i
          hantei+=1
          break
      if hantei>0:
        if tempedge==startedge:return 1
        else:
         tuikalist.append(tempedge)
         imaedge=tempedge
         tempv01=[ashape.edge(imaedge).v0,ashape.edge(imaedge).v1]
         tempv01.remove(vv)
         vv=tempv01[0]
         bpointlist.append(vv)
         mugen+=1
         if mugen>5000:return False

      else:return False
    else:return False




def return_henlist(face):
  #面番号から面を構成する辺の番号を返す
  #前後にsetup_winged_edgeとclean_winged_edgeが必要

  tempvlist=xshade.scene().active_shape().face(face).vertex_indices

  henlist=[]
  for i in tempvlist:
    tempf=xshade.scene().active_shape().eccwfv(face,i,False)
    henlist.append(tempf)

  return henlist





dousasuru=1

if xshade.scene().active_shape().type==7:
  if xshade.scene().selection_mode!=1 or xshade.scene().is_modify_mode==False:
    dousasuru=0
  else:
    #選択されている辺のリストを作るとともに、辺が一つだけ選択されてるか判定
    activeedgelist=[]
    for i in range(xshade.scene().active_shape().number_of_edges):
      if xshade.scene().active_shape().edge(i).active_order>0:
        activeedgelist.append(i)
    if len(activeedgelist)!=1:
     dousasuru=0
else:
  dousasuru=0


if dousasuru>0:
  #上位パートに変換がかかっているなら動作しない

  if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
    dousasuru=0
    dialog=xshade.create_dialog()
    dialog.append_push_button('上位パートに変換がかかっているため')
    dialog.append_push_button('スクリプトが実行できません')
    
    dialog.ask('エラー')



if dousasuru==1:

  startedge=activeedgelist[0]

  xscene=xshade.scene()
  ashape=xshade.scene().active_shape()


  bpointlist=[]

  #後で呼び出すリストを作成
  velist=[] #頂点に接続されている辺（接続辺）のリスト（頂点番号順に並べてる）
  eflist=[] #辺の隣接面リスト（辺番号順に並べている）

  for i in range(ashape.total_number_of_control_points):
    velist.append([])

  for i in range(ashape.number_of_edges):
    eflist.append([])

  ashape.setup_winged_edge()

  for i in range(ashape.number_of_edges):
    vv0=ashape.edge(i).v0
    vv1=ashape.edge(i).v1
    temp=velist[vv0]
    temp.append(i)
    velist[vv0]=temp

    temp=velist[vv1]
    temp.append(i)
    velist[vv1]=temp

  for i in range(ashape.number_of_faces):
    henlist=return_henlist(i)
    for gg in henlist:
      temp=eflist[gg]
      temp.append(i)
      eflist[gg]=temp

  ashape.clean_winged_edge()  


  #最初の辺の隣接面の数が1以下か？

  if len(eflist[startedge])>1:
    dousasuru=0


if dousasuru==1:

  tuikalist=[]
  ev0=ashape.edge(startedge).v0
  ev1=ashape.edge(startedge).v1

  bpointlist.append(ev0)
  error=boundary_sel2(ashape,startedge,ev0,eflist,velist)


  if error==1:
    #元の形状をクリップボードにコピー
    xshade.scene().active_shape().copy()
    xshade.scene().enter_modify_mode()

    #面を閉じて向きを統一
    xshade.scene().active_shape().append_face(bpointlist)
    xshade.scene().active_shape().adjust_face_direction()
    #選択状態を変更
    xshade.scene().selection_mode=2
    for i in bpointlist:
      xshade.scene().active_shape().vertex(i).active=True
    xshade.scene().selection_mode=1

    #やり直すか聞く
    dialog=xshade.create_dialog()
    idx3=dialog.append_push_button('結果を確定する場合はokを')
    idx4=dialog.append_push_button('取り消す場合はcancelを押してください')
    xshade.idle(120)
    kekka2=dialog.ask('穴を埋める')

    #キャンセルなら形状を削除してクリップボードの形状を元に戻す
    if kekka2==False:
      idou1=0
      if xshade.scene().active_shape().has_sis==True:
        idou1=1
      xshade.scene().paste()
      xshade.scene().select_sister(1)
      xshade.scene().clear()
      if idou1==1:
        xshade.scene().select_brother()
      xshade.scene().enter_modify_mode()
      xshade.scene().active_shape().edge(startedge).active=True
      ashape=xshade.scene().active_shape()


    if kekka2==True:
      renzoku=0
#戻す終わり

    #マニピュレーターの位置を修正
    xshade.scene().exit_modify_mode()
    xshade.scene().enter_modify_mode()


