﻿# -*- coding: utf-8 -*-



import copy
import math

#ガイドラインムーブ

#選択している頂点だけを弟階層のガイドラインにあわせて移動します
#上位パートに変換がかかっていると使用できないように変更（2010.03.03）
#shade1301に対応

#動作条件
#選択形状がポリゴンメッシュ
#編集モードに入っている
#頂点選択モード
#頂点が二つ以上選択されている（ｘ、ｙ、ｚ座標の値が異なる）
#弟形状に「gmove」というパートとその中にガイドラインが存在する

#ローカル座標モードや、上位パートに変換がかかっていると結果が不正になります


#設定項目
#直行軸　「ｘ軸」「ｙ軸」「ｚ軸」・・・ガイドラインの名前の頭につけておく
#ガイドラインの分割数・・・・分割数が大きいほど精度が高くなる




dousasuru=0

xscene=xshade.scene()
ashape=xshade.scene().active_shape()



if ashape.type==7 and xscene.is_modify_mode==True:
  if xscene.selection_mode==2:
    aplist=[]#選択頂点リスト
    for i in range(ashape.total_number_of_control_points):
      if ashape.vertex(i).active==True:
        aplist.append(i)

    if len(aplist)>1:dousasuru=1


if dousasuru>0:
  #上位パートに変換がかかっているなら動作しない

  if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
    dousasuru=0
    dialog=xshade.create_dialog()
    dialog.append_push_button('上位パートに変換がかかっているため')
    dialog.append_push_button('スクリプトが実行できません')
    
    dialog.ask('エラー')



if dousasuru==1:

  #選択部のバウンディングボックス

  minx=ashape.vertex(aplist[0]).position[0]
  maxx=ashape.vertex(aplist[0]).position[0]
  miny=ashape.vertex(aplist[0]).position[1]
  maxy=ashape.vertex(aplist[0]).position[1]
  minz=ashape.vertex(aplist[0]).position[2]
  maxz=ashape.vertex(aplist[0]).position[2]

  minxp=aplist[0]
  minyp=aplist[0]
  minzp=aplist[0]
  maxxp=aplist[0]
  maxyp=aplist[0]
  maxzp=aplist[0]

  for i in aplist:
    tpos=ashape.vertex(i).position
    if tpos[0]<minx:
      minxp=i
      minx=tpos[0]

    if tpos[1]<miny:
      minyp=i
      miny=tpos[1]

    if tpos[2]<minz:
      minzp=i
      minz=tpos[2]

    if tpos[0]>maxx:
      maxxp=i
      maxx=tpos[0]

    if tpos[1]>maxy:
      maxyp=i
      maxy=tpos[1]

    if tpos[2]>maxz:
      maxzp=i
      maxz=tpos[2]

  #オブジェクト全体のバウンディングボックス

  ominx=ashape.vertex(0).position[0]
  omaxx=ashape.vertex(0).position[0]
  ominy=ashape.vertex(0).position[1]
  omaxy=ashape.vertex(0).position[1]
  ominz=ashape.vertex(0).position[2]
  omaxz=ashape.vertex(0).position[2]

  ominxp=0
  ominyp=0
  ominzp=0
  omaxxp=0
  omaxyp=0
  omaxzp=0

  for i in range(ashape.total_number_of_control_points):
    tpos=ashape.vertex(i).position
    if tpos[0]<ominx:
      ominxp=i
      ominx=tpos[0]

    if tpos[1]<ominy:
      ominyp=i
      ominy=tpos[1]

    if tpos[2]<ominz:
      ominzp=i
      ominz=tpos[2]

    if tpos[0]>omaxx:
      omaxxp=i
      omaxx=tpos[0]

    if tpos[1]>omaxy:
      omaxyp=i
      omaxy=tpos[1]

    if tpos[2]>omaxz:
      omaxzp=i
      omaxz=tpos[2]



#選択形状がポリゴンメッシュで弟階層にガイドラインが存在しない場合はまず作成して終了
#ある場合も「変形を行う」と「ガイドラインの新規作成」で選択
#軸をたずねる（ガイドラインの頭に軸ｘ、ｙ、ｚをつける）
#ガイドラインはレンダリング対象外

if dousasuru==1:
  gkesu=0
  if ashape.has_bro==True:
    if ashape.bro.name=='gmove': 
      dialog=xshade.create_dialog()
      idx=dialog.append_radio_button('/変形を行う/ガイドラインの新規作成')
      dialog.set_value(idx,0)

      xshade.idle(120)
      kekka7=dialog.ask('ガイドラインムーブ')
      if kekka7==False:dousasuru=0
      else:
        tmode=dialog.get_value(idx)
        if tmode==1:
          dousasuru=3
          gkesu=1

    else:
      dousasuru=3
  else:
    dousasuru=3




if dousasuru==3:



  #ガイドラインの作成
  dialog=xshade.create_dialog()
  dialog.append_push_button('ガイドラインムーブ用')
  idx=dialog.append_radio_button('ガイドライン/x軸と平行/y軸と平行/z軸と平行')
  idx2=dialog.append_radio_button('ガイドラインの位置/選択部のやや外/オブジェクト全体のやや外')

  dialog.set_value(idx,0)
  dialog.set_value(idx2,0)
  xshade.idle(120)

  kekka8=dialog.ask('ガイドラインの作成')
  if kekka8==True:
    gmode=dialog.get_value(idx)
    iti=dialog.get_value(idx2)

    #ガイドラインの新規作成の場合は前のガイドラインを非表示に
    if gkesu==1:
      xscene.select_brother(1)
      xscene.hide_active()
      xscene.select_sister()


    if gmode==0:

      #オフセット量を決定
      atumi=pow( (maxx-minx)**2+(maxy-miny)**2+(maxz-minz)**2,0.5)*0.2

      if iti==0:
        itix=maxx+atumi
        itiy=maxy+atumi
        itiz=maxz+atumi
      else:
        itix=omaxx+atumi
        itiy=omaxy+atumi
        itiz=omaxz+atumi


      #パートの作成
      xshade.scene().begin_creating()
      xshade.scene().create_part('gmove')
      xshade.scene().end_creating()


      #ガイドライン線形状の作成
      xshade.scene().begin_creating()
      xshade.scene().create_line('xガイドライン',[[minx,itiy,itiz],[maxx,itiy,itiz]],False)
      xshade.scene().end_creating()


      #パートの作成
      xshade.scene().begin_creating()
      xshade.scene().create_part('~基準線')
      xshade.scene().end_creating()

      xshade.scene().begin_creating()
      xshade.scene().create_line('開始ライン',[[minx,itiy,itiz],[maxx,itiy,itiz]],False)
      xshade.scene().end_creating()

      xscene.select_parent()
      xshade.scene().active_shape().rendering=0
      xscene.select_sister()


    if gmode==1:

      #オフセット量を決定
      atumi=pow( (maxx-minx)**2+(maxy-miny)**2+(maxz-minz)**2,0.5)*0.2

      if iti==0:
        itix=maxx+atumi
        itiy=maxy+atumi
        itiz=maxz+atumi
      else:
        itix=omaxx+atumi
        itiy=omaxy+atumi
        itiz=omaxz+atumi


      #パートの作成
      xshade.scene().begin_creating()
      xshade.scene().create_part('gmove')
      xshade.scene().end_creating()


      #ガイドライン線形状の作成
      xshade.scene().begin_creating()
      xshade.scene().create_line('yガイドライン',[[itix,miny,itiz],[itix,maxy,itiz]],False)
      xshade.scene().end_creating()


      #パートの作成
      xshade.scene().begin_creating()
      xshade.scene().create_part('~基準線')
      xshade.scene().end_creating()

      xshade.scene().begin_creating()
      xshade.scene().create_line('開始ライン',[[itix,miny,itiz],[itix,maxy,itiz]],False)
      xshade.scene().end_creating()

      xscene.select_parent()
      xshade.scene().active_shape().rendering=0
      xscene.select_sister()


    if gmode==2:

      #オフセット量を決定
      atumi=pow( (maxx-minx)**2+(maxy-miny)**2+(maxz-minz)**2,0.5)*0.2

      if iti==0:
        itix=maxx+atumi
        itiy=maxy+atumi
        itiz=maxz+atumi
      else:
        itix=omaxx+atumi
        itiy=omaxy+atumi
        itiz=omaxz+atumi


      #パートの作成
      xshade.scene().begin_creating()
      xshade.scene().create_part('gmove')
      xshade.scene().end_creating()


      #ガイドライン線形状の作成
      xshade.scene().begin_creating()
      xshade.scene().create_line('zガイドライン',[[itix,itiy,minz],[itix,itiy,maxz]],False)
      xshade.scene().end_creating()


      #パートの作成
      xshade.scene().begin_creating()
      xshade.scene().create_part('~基準線')
      xshade.scene().end_creating()

      xshade.scene().begin_creating()
      xshade.scene().create_line('開始ライン',[[itix,itiy,minz],[itix,itiy,maxz]],False)
      xshade.scene().end_creating()

      xscene.select_parent()
      xshade.scene().active_shape().rendering=0
      xscene.select_sister()




if dousasuru==1:

  #変形を行う

  ziku=0#ガイドラインの軸　0がｘ軸、1がy軸、2がｚ軸


  #ガイドライン（線形状）のコントロールポイント数を計測と軸の確認
  xscene.select_brother()
  xscene.select_child()
  bunkatu=xshade.scene().active_shape().total_number_of_control_points-1

  if xshade.scene().active_shape().name=='xガイドライン':ziku=0
  if xshade.scene().active_shape().name=='yガイドライン':ziku=1
  if xshade.scene().active_shape().name=='zガイドライン':ziku=2

  xscene.select_parent()
  xscene.select_sister()


  #ここに初期値
  renzoku=1

  bunkatu=1000

  dfbunkatu=bunkatu

  while(renzoku==1):
    #ダイアログ表示
    dialog=xshade.create_dialog_with_uuid('0x51900234')

    dialog.append_default_button()

    idx3=dialog.append_int('ガイドラインの分割数(デフォルト:'+str(dfbunkatu)+'）')

    dialog.set_default_value(idx3,dfbunkatu)

    xshade.idle(120)

    kekka=dialog.ask('ガイドラインムーブ')

    if kekka==False:renzoku=0

    else:
      bunkatu=dialog.get_value(idx3)
      if bunkatu<1:bunkatu=1


      #基準点（開始線の一つ目のコントロールポイントの座標を取得)
      xscene.select_brother()
      xscene.select_child()
      xscene.select_brother()
      xscene.select_child()
      ttpos=xshade.scene().active_shape().control_point(0).position
      kizyunpos=[ttpos[0],ttpos[1],ttpos[2]]

      xscene.select_parent()

      xscene.select_sister()


      #ガイドライン（のコピー）を自由曲面パートに入れて複製つくってポリゴンメッシュに変換して頂点情報を取得
      pposlist=[]

      xscene.copy()

      xscene.begin_creating()
      xscene.create_surface_part()
      xscene.end_creating()

      xscene.paste()
      xscene.paste()
      if ziku==0:
        xscene.move_object([0,0,0],None,None,[0,0,50])
      if ziku==1:
        xscene.move_object([0,0,0],None,None,[50,0,0])
      if ziku==2:
        xscene.move_object([0,0,0],None,None,[0,50,0])

      xscene.select_parent()

      xscene.active_shape().convert_to_polygon_mesh_with_divisions(1,bunkatu)

      for i in range(bunkatu+1):
        tposp=xscene.active_shape().vertex(i).position
        pposlist.append([tposp[0],tposp[1],tposp[2]])

      #バウンディングボックス
      pminx=pposlist[0][0]
      pmaxx=pposlist[0][0]
      pminy=pposlist[0][1]
      pmaxy=pposlist[0][1]
      pminz=pposlist[0][2]
      pmaxz=pposlist[0][2]

      for i in pposlist:
        if i[0]<pminx:pminx=i[0]
        if i[0]>pmaxx:pmaxx=i[0]
        if i[1]<pminy:pminy=i[1]
        if i[1]>pmaxy:pmaxy=i[1]
        if i[2]<pminz:pminz=i[2]
        if i[2]>pmaxz:pmaxz=i[2]


      xscene.clear()
      xscene.select_parent()
      xscene.select_sister()

      #方向の検査
      if ziku==0:
        if abs(pminy-pmaxy)<0.001:houkou=2
        else:houkou=1

      if ziku==1:
        if abs(pminx-pmaxx)<0.001:houkou=2
        else:houkou=0
    
      if ziku==2:
        if abs(pminx-pmaxx)<0.001:houkou=1
        else:houkou=0
    
    



      #元の形状をクリップボードにコピー
      ashape.copy()
      xscene.enter_modify_mode()


      #個々の頂点を移動
      for i in aplist:
        tpos=ashape.vertex(i).position
        motopos=[tpos[0],tpos[1],tpos[2]]

        if ziku==0:
          dist2=abs(pposlist[0][0]-tpos[0])
          nearpos=pposlist[0]
          for gg in pposlist:
            tdist=abs(gg[0]-tpos[0])
            if tdist>dist2:break
            else:
              dist2=tdist
              nearpos=gg

        if ziku==1:
          dist2=abs(pposlist[0][1]-tpos[1])
          nearpos=pposlist[0]
          for gg in pposlist:
            tdist=abs(gg[1]-tpos[1])
            if tdist>dist2:break
            else:
              dist2=tdist
              nearpos=gg

        if ziku==2:
          dist2=abs(pposlist[0][2]-tpos[2])
          nearpos=pposlist[0]
          for gg in pposlist:
            tdist=abs(gg[2]-tpos[2])
            if tdist>dist2:break
            else:
              dist2=tdist
              nearpos=gg


        #移動距離を求める
        distx=nearpos[0]-kizyunpos[0]
        disty=nearpos[1]-kizyunpos[1]
        distz=nearpos[2]-kizyunpos[2]

        #誤差はカット
        if abs(distx)<0.0001:distx=0
        if abs(disty)<0.0001:disty=0
        if abs(distz)<0.0001:distz=0



        #頂点の移動

#        if houkou==0:
#          ttpos=[tpos[0]+distx,tpos[1],tpos[2]]
#        if houkou==1:
#          ttpos=[tpos[0],tpos[1]+disty,tpos[2]]
#        if houkou==2:
#          ttpos=[tpos[0],tpos[1],tpos[2]+distz]

        ttpos=[tpos[0]+distx,tpos[1]+disty,tpos[2]+distz]
        if ziku==0:ttpos[0]=motopos[0]
        if ziku==1:ttpos[1]=motopos[1]
        if ziku==2:ttpos[2]=motopos[2]


        ashape.vertex(i).position=ttpos


      #頂点のマージ
#      ashape.cleanup_redundant_vertices()

#      print [ziku,houkou]


      #選択箇所の再選択
      xshade.scene().enter_modify_mode()
      for i in aplist:
        ashape.vertex(i).active=True      


      #元に戻すか聞く
      dialog=xshade.create_dialog()
      idx3=dialog.append_push_button('処理を確定しますか?')
      xshade.idle(120)
      kekka=dialog.ask('ガイドラインムーブ')

      if kekka==True:renzoku=0

      if kekka==False:
        idou1=0
        if xshade.scene().active_shape().has_sis==True:
          idou1=1
        xshade.scene().paste()
        xshade.scene().select_sister(1)
        xshade.scene().clear()
        if idou1==1:
          xshade.scene().select_brother()
        xshade.scene().enter_modify_mode()
        ashape=xshade.scene().active_shape() 
        for i in aplist:
          ashape.vertex(i).active=True






